#ifndef IWS_APP_H
#define IWS_APP_H

/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

#include <iws/handler.h>

/***********************************************************************
class IWS_Application
***********************************************************************/
class IWS_Application : public EW_Application
{
	public:
		static EW_EventContext *eventContext;

		IWS_Application(void);
		virtual ~IWS_Application(void);

		virtual const char * GetName(void) const { return ""; }
		virtual const char * GetParameterUsage(void) const { return ""; }

		virtual GPL_Boolean Initialize(void);
		virtual void Finalize(void);

		virtual void LoadConfiguration(const int argc, const char ** argv, const char ** envp);
		virtual void GetApproximateSize(const char *string, long & width, long & height);

	protected:
		virtual void Process(void);
};

/***********************************************************************
class IWS_ExitApplicationHandler
***********************************************************************/
class IWS_ExitApplicationHandler : public IWS_Handler
{
	public:
		IWS_ExitApplicationHandler(void) {}
		virtual ~IWS_ExitApplicationHandler(void) {}

		virtual void HandleEvent(const GPL_String & string);
};

/***********************************************************************
class IWS_LookShiftHandler
***********************************************************************/
class IWS_LookShiftHandler : public IWS_Handler
{
	public:
		IWS_LookShiftHandler(void) {}
		virtual ~IWS_LookShiftHandler(void) {}

		virtual void HandleEvent(const GPL_String & string);
};

extern IWS_Application *IWS_APP;
extern IWS_Application *IWS_DEFAULT_APP;

#endif /* IWS_APP_H */
