
/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

class IWS_Page : public GPL_Depictable
{
	protected:
		GPL_Map<EW_Window *, GPL_Boolean> windowState;
	public:
		IWS_Page();
virtual	~IWS_Page();

		GPL_Boolean operator== (const IWS_Page & p) const
		{
			return windowState == p.windowState;
		}

		void Show (void);
		void Hide (void);

		void AddWindow (EW_Window * window, const GPL_Boolean shown = TRUE);
		void RemoveWindow (EW_Window * window);

		// GPL_Persistent
virtual	GPL_Boolean Print (GPL_String & string, const GPL_Verbosity verbosity =
			GPL_VERBOSITY_CONCISE) const;
};

class IWS_Book
{
	protected:
		GPL_String currentPage;
		GPL_Map<GPL_String, IWS_Page> pages;
	public:
		static const GPL_String defaultPage;
		IWS_Book();
virtual	~IWS_Book();

		const GPL_String & GetShownPage (void) const;
		void ShowPage (const GPL_String & page);
inline 	void AddWindowToPage (EW_Window * window,const GPL_Boolean shown=TRUE)
		{
			AddWindowToPage (window, defaultPage, shown);
		}
virtual	void AddWindowToPage (EW_Window * window, const GPL_String & page,
			const GPL_Boolean shown = TRUE);
inline	void RemoveWindowFromPage (EW_Window * window)
		{
			RemoveWindowFromPage (window, defaultPage);
		}
virtual	void RemoveWindowFromPage(EW_Window *window, const GPL_String &page);
};
