
/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

#include <mte/mte.h>

#ifdef MTE_STANDALONE
#define osdMilliSleep(x) sleep(1)
#endif

class MTE_NopTask : public MTE_Task
{
	public:
		MTE_NopTask(){}
virtual	~MTE_NopTask(){}
		void Work()
		{
			fprintf(stderr,"thread here\n");
			osdMilliSleep(2000);
			Stop();
		}
};

class MTE_TestTask : public MTE_Task
{
	private:
		long reps;
	public:
		MTE_TestTask(){reps = 0;}
virtual	~MTE_TestTask(){}

		void Work()
		{
			osdMilliSleep(1000);
			reps++;
			wbaLog("MTE LOG", "MTE_TestTask callback %d 0x%x", reps, this);
			osdMilliSleep(250);
			{
				MTE_GUARD();
				osdMilliSleep(1000);
				wbaLog("MTE LOG", "MTE_TestTask protected 0x%x", this);
			}
			osdMalloc(1000);
			if(reps == 3) 
			{
				Done();
			}
			Stop();
		}
};

class MTE_ChildTask : public MTE_Task
{
	private:
		MTE_Mutex *mutex;
	public:
		MTE_ChildTask(MTE_Mutex *m){mutex = m;}
virtual	~MTE_ChildTask(){}

		void Work()
		{
			wbaLog("MTE LOG", "2 child here");
			if(mutex->Lock())
			{
				wbaLog("MTE LOG","4 child locked");
			}
			else
			{
				wbaLog("MTE WARNING","child lock failed");
			}

			if(mutex->Unlock())
			{
				wbaLog("MTE LOG","5 child unlocked");
			}
			else
			{
				wbaLog("MTE WARNING","child unlock failed");
			}

			Done();
			Stop();
		}
};

int main(const int argc, const char **argv, const char **envp)
{
#ifndef MTE_STANDALONE
	{
		GPL_Aware gpl;
		WBA_Aware wba;
		MTE_Aware mte;

		WBA_ENV.LoadEnvVariables(envp, FALSE);
		WBA_ENV.LoadCommandLine(argc, argv, TRUE);
	}
#endif


#if 0
	long et,cnt;
	et = osdTimer();

	MTE_Group group;
	MTE_TestTask t1,t2,t3;
	group.Add(&t1);
	group.Add(&t2);
	group.Add(&t3);

	cnt = 0;
	do {
		wbaLog("MTE LOG", "round %d", cnt);
		cnt++;
	} while(group.Run());

	MTE_Mutex mutex;
	MTE_ChildTask child(&mutex);
	if(mutex.Lock())
	{
		wbaLog("MTE LOG","1 parent locked");
	}
	else
	{
		wbaLog("MTE WARNING","parent lock failed");
	}

	child.Start();

	osdSleep(3);

	if(mutex.Unlock())
	{
		wbaLog("MTE LOG","3 parent unlocked");
	}
	else
	{
		wbaLog("MTE WARNING","parent unlock failed");
	}

	osdSleep(3);
#endif

#if 1
	while(1)
	{
		MTE_NopTask task;
		task.Start();
		osdMilliSleep(10);
	}
#endif
	

#if 0
	MTE_TestTask t1,t2,t3;
	wbaLog("MTE LOG", "before spawn");
	t1.Start();
	t2.Start();
	t3.Start();
	wbaLog("MTE LOG", "btwn spawn & wait");
	t1.Wait();
	t2.Wait();
	t3.Wait();
	wbaLog("MTE LOG", "after wait");
#endif

	//wbaLog("MTE LOG", "time elapsed: %d ms", osdTimer() - et);
}

