#ifndef DNA_HANDLER_H
#define DNA_HANDLER_H

/******************************************************************************

Coral Tree dna/handler.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <gpl/gpl.h>
#include <dna/message.h>

/******************************************************************************
class DNA_MessageHandler
******************************************************************************/
class DNA_MessageHandler
{
	public:
		DNA_MessageHandler(void) : hasExpired(FALSE) {}
		virtual ~DNA_MessageHandler(void) {}

		virtual GPL_Boolean GetExpired(void) { return hasExpired; }

		virtual GPL_Boolean HandleMessage(DNA_Message & message,
											GPL_Boolean & consumedMessage);

		virtual void Expire(void) { hasExpired = TRUE; }

	protected:
		GPL_Boolean hasExpired;
};

/******************************************************************************
class DNA_MessageHandlerWithTimeout
******************************************************************************/
class DNA_MessageHandlerWithTimeout : public DNA_MessageHandler
{
	public:
		DNA_MessageHandlerWithTimeout(const unsigned long milliseconds = 0);
		virtual ~DNA_MessageHandlerWithTimeout(void) {}

		virtual GPL_Boolean GetExpired(void);

	protected:
		GPL_Time inceptionTime;
		GPL_Time interval;
};

#endif /* DNA_HANDLER_H */
