#ifndef DNA_TCP_H
#define DNA_TCP_H

/******************************************************************************

Coral Tree dna/tcp.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <gpl/gpl.h>
#include <dna/connect.h>
#include <dna/ipsocket.h>

/******************************************************************************
class DNA_TCPConnectionImp

Transaction Control Protocol peer connection implementation.
******************************************************************************/
class DNA_TCPConnectionImp : public DNA_ConnectionImp
{
	public:
		DNA_TCPConnectionImp(void);
		virtual ~DNA_TCPConnectionImp(void);

		virtual SOCKET_HANDLE GetSocketHandle(void) const
		{
			return socket.GetSocketHandle();
		}
		virtual DNA_Point *GetDestination(void) const { return destination; }

		virtual long Compare(const DNA_BusImp *imp) const;

		virtual void SetDestination(DNA_Point *p);
		virtual void SetBackLog(const unsigned long b);

		virtual void Reset(void);
		virtual GPL_Boolean Accept(DNA_ConnectionImp *i, DNA_Error & error);
		virtual GPL_Boolean Connect(DNA_Error & error);
		virtual GPL_Boolean Disconnect(DNA_Error & error);
		virtual GPL_Boolean Open(DNA_Error & error);
		virtual GPL_Boolean Bind(DNA_Point *point, DNA_Error & error);
		virtual GPL_Boolean Close(DNA_Error & error);
		virtual GPL_Boolean Read(void *buffer, const unsigned long size,
									unsigned long & length, DNA_Error & error);
		virtual GPL_Boolean Read(void *buffer, const unsigned long size,
									const long timeout, unsigned long & length,
									DNA_Error & error);
		virtual GPL_Boolean Write(void *buffer, const unsigned long size,
									unsigned long & length, DNA_Error & error);

		// GPL_Object
		GPL_OBJECT_INTERFACE(DNA_TCPConnectionImp);

	protected:
		DNA_IPSocket socket;
		DNA_IPPoint *destination;
		GPL_Boolean backLogSet;
};

#define	DNA_DEFAULT_TCP_BACK_LOG	5

#endif /* DNA_TCP_H */
